<?php

ini_set("display_errors", true);
ini_set('session.save_path',"sessions");


/**
* Clase FindMe, s'encarrega de gestionar les peticions externes
*
* @author	Javi Filella <txusko@gmail.com>
* @date		2011-04
*/
class FindMe {

	protected $db 			= null;
	protected $result 		= false;
	protected $session_id 	= false;

    /**
	* Constructor de la clase
	*/
	function __construct($session_id = "") {
		if($session_id) {
			$this->session_id = $session_id;
		}
	}
	
	function checkSession() {
		$this->init();
		if(isset($_SESSION["user"])) {
			return true;
		}
		return false;
	}
	
	/*
	* Per una extranya rao si hi ha mes d'una crida a funcions es perd la conexio a la base de dades.
	* per lo que la inicio en cada funció
	*/
	function init($session_id = "") {
		//Iniciem sessio
		if($this->getSessionId()) {
			session_id($this->getSessionId());
		}
		session_start();
		$this->session_id = session_id();
		
		//Conexio a base de dades
		$MYSQL['SERVER'] = 'localhost';
		$MYSQL['USER'] = 'root';
		$MYSQL['PASSWORD'] = '';
		$MYSQL['DB'] = 'findme';
		$MYSQL['PERSISTENT'] = 0;
		$this->db = new MysqlDb($MYSQL['SERVER'], $MYSQL['USER'], $MYSQL['PASSWORD'], $MYSQL['DB'], $MYSQL['PERSISTENT']);
	}
	
	public function getSessionId() {
		return $this->session_id;
	}
	
	/**
	* Funció test del servidor
	*/
	function test() {
		return "test ok";
		//return $this->db->exec("select * from users");
	}
	
	/**
	* Funció que retorna els resultats en un format correcte
	*/
	function sendResult() {
		if($this->result) {
			$ret = $this->result;
			$this->result = false;
			return $ret;
		}
		return array("error" => "Empty result");
	}
	
	/**
	* Funció que retorna els resultats en un format json
	*/
	function sendJsonResult() {
		if($this->result) {
			$ret = json_encode($this->result);
			$this->result = false;
			return $ret;
		}
		if($this->checkSession()) {
			return json_encode(array("error" => "Empty result"));
		} else {
			return json_encode(array("error" => "-1"));
		}
	}
	
	/********************** SUBSITEMA DE REGISTRE *************************/
	
	public function getUserInfo() {
		if($this->checkSession()) {
			$data = $this->getUserId($_SESSION["user"]["Id"]);
			$data["friends"] = $this->getFriends($_SESSION["user"]["Id"]);
			$this->result = $data;
		}
		return $this->sendJsonResult();
	}
	
	protected function getUserId($id) {
		$sql = "select a.Id, a.email, a.name, a.password, b.longitud, b.latitud, b.date as last_seen, a.profile, a.autolocation
				from users as a
					left join currentlocation as b on a.Id=b.IdUser
					where a.Id='".$id."'";
		if($data = $this->db->select($sql)) {
			return $data[0];
		}
		return false;
	}
	
	/**
	* Funció signUp per crear l'usuari
	*/
	public function signUp($login,$password) {
		$name = substr($login,0,strpos($login,"@"));			
		//Iniciem BBDD
		$this->init();
		$sql = "select email 
				from users 
				where email='$login'";
		//Busquem que no existeixi el email a la base de dades
		if(!$data = $this->db->select($sql)) {
			//Donem d'alta l'usuari
			//Per defecte el marquem com a esborrat per que l'usuari l'activi via email
			$ins = "insert into users (email, password, name, registered)
					values ('".$login."','".$password."','".$name."',now())";
			/*$ins = "insert into users (email, password, name, registered, deleted)
					values ('".$login."','".$password."','".$name."',now(), now())";*/
			if($id = $this->db->insert($ins)) {
				$this->result = array("success" => "User created successfully. Check your email to activate your account.");
				//Tot correcte, recuperem les dades
				/*$data = $this->getUserId($id);
				//Creem una cadena que en servira per activar el compte mes tard
				$secure = "ACT|".sha1($data["registered"].$login);
				//Enviem email d'activació
				if($this->activateEmailAccount($login,$name,$secure)) {
					//Retornem el resultat
					$this->result = array("success" => "User created successfully. Check your email to activate your account.");
				} else {
					//Error
					$this->result = array("error" => "Error sending activation email.");
				}*/
				
			} else {
				//Error insertant a base de dades
				$this->result = array("error" => "Error inserting user");
			}
		} else {
			//Error usuari ja exiteix
			if($data[0]["deleted"]) {
				$this->result = array("error" => "Error user deleted");
			} else {
				//Si no ha entrat mai es que no ha activat el compte, li reenviem el email d'activacio
				/*if(!$data[0]["last_seen"]) {
					//Creem una cadena que en servira per activar el compte
					$secure = "ACT|".sha1($data[0]["registered"].$login);
					if($this->activateEmailAccount($login,$name,$secure)) {
						//Retornem el resultat
						$this->result = array("success" => "Check your email to activate your account.");
					} else {
						//Error
						$this->result = array("error" => "Error sending activation email.");
					}
				}*/
				$this->result = array("error" => "Error user already exists");
			}
		}
		return $this->sendJsonResult();
	}
	
	/**
	* Funció signIn per logejar a l'usuari
	*/
	public function signIn($login,$password) {
		$this->init();
		$sql = "select * 
				from users 
				where email='".$login."' and password='".$password."'";
				//print $sql;
		if($data = $this->db->select($sql)) {
			if(!$data[0]["deleted"]) {
				//Tot correcte
				$this->result = array("success" => "User signed in", "data" => $data[0]);
				//Guardem a sessio les dades de l'usuari
				$_SESSION["user"] = $data[0];
				//Actualitzem la data de l'ultim acces
				$this->db->update("update users 
									set last_seen=now() 
									where Id='".$data[0]["Id"]."'");
			} else {
				//Error usuari esborrat
				$this->result = array("error" => "Error user deleted");
			}
		} else {
			//Error insertant a base de dades
			$this->result = array("error" => "Error user or password incorrect");
		}
		return $this->sendResult();
	}
	
	/**
	* Desactiva el compte de l'usuari
	*/
	public function deleteAccount($login, $password) {
		if($this->checkSession()) {
			$sql = "update users 
					set deleted=now() 
					where email='".$login."' and password='".$password."'";
			if($this->db->update($sql)) {
				$this->result = array("success" => "User deleted");
			} else {
				$this->result = array("error" => "Error deleting user");
			}
		}
		return $this->sendJsonResult();
			
	}
	
	/**
	* Activa el compte de l'usuari
	*/
	public function activateAccount($secure) {
		$this->init();
		$sql = "select Id from users 
				where sha(concat(deleted,email)) = '".$secure."'";
		if($data = $this->db->select($sql)) {
			$sql = "update users
					set deleted=null
					where Id='".$data[0]["Id"]."'";
			if($this->db->update($sql)) {
				$this->result = array("success" => "User activated");
			} else {
				$this->result = array("error" => "Error activating user");
			}
		} else {
			$this->result = array("error" => "Error account not found");
		}
		return $this->sendResult();
	}
	
	/********************** FI SUBSITEMA DE REGISTRE *************************/
	
	
	/**********************	SUBSISTEMA GESTIO AMISTATS ********************/
	
	public function findUser($name) {
		if($this->checkSession()) {
			$sql = "select email,name 
					from users 
					where name like '%".$name."%' or email like '".$name."'";
			if($data = $this->db->select($sql)) {
				$this->result = array("success" => "User find it", "data" => $data);
			} else {
				$this->result = array("error" => "No results found");
			}
		}
		return $this->sendJsonResult();
	}
	
	public function getFriends($idUser) {
		$data = false;
		if($this->checkSession()) {
			$sql = "select b.Id,b.email,b.name,b.profile,c.longitud,c.latitud,c.date as last_seen
					from userfriends as a 
  						inner join users as b on a.IdUserB=b.Id
  						left join currentlocation as c on b.Id=c.IdUser
					where a.accepted and a.IdUserA=".$idUser;
			$data1 = $this->db->select($sql);
			
			$sql = "select b.Id,b.email,b.name,b.profile,c.longitud,c.latitud,c.date as last_seen
					from userfriends as a 
  						inner join users as b on a.IdUserA=b.Id
  						left join currentlocation as c on b.Id=c.IdUser
					where a.accepted a.IdUserB=".$idUser;
			$data2 = $this->db->select($sql);
			
			if($data1 && $data2) {
				$data = array_merge($data1,$data2);
			} elseif($data1) {
				$data = $data1;
			} elseif($data2) {
				$data = $data2;
			}
		}
		return $data;
	}
	public function getFriendsJson() {
		if($this->checkSession()) {
			if($data = $this->getFriends($_SESSION["user"]["Id"])) {
				$this->result = array("success" => "Ok", "friends" => $data);
			} else {
				$this->result = array("error" => "No friends");
			}
		}
		return $this->sendJsonResult();
	}
	
	public function checkConnection($idUserA, $idUserB) {
		if($this->checkSession()) {
			$sql = "select Id from userfriends where IdUserA='$idUserA' and IdUserB='$idUserB'";
			if($data = $this->db->select($sql)) {
				return $data[0]["Id"];
			}
			$sql = "select Id from userfriends where IdUserA='$idUserB' and IdUserB='$idUserA' and accepted";
			if($data = $this->db->select($sql)) {
				return $data[0]["Id"];
			}
			return false;
		}
	}
	
	public function addFriend($idUserB) {
		
		if($this->checkSession()) {
			
			$idUserA = $_SESSION["user"]["Id"];
			$dataA = $this->getUserId($idUserA);
			$dataB = $this->getUserId($idUserB);
			if($dataA && $dataB) {
				//Si la conexio esta feta la validem
				if(!$this->checkConnection($idUserA, $idUserB)) {
					//Creem la conexio i la deixem pendent de validar
					$ins = "insert into userfriends (IdUserA, IdUserB, date, accepted)
							values ('$idUserA','$idUserB',now(), '1')";
					if($this->db->insert($ins)) {
						//$this->addNotification($idUserB,"newfriend");
						$this->result = array("success" => "Request inserted");
					} else {
						$this->result = array("error" => "Error inserting request");
					}
				} else {
					$this->result = array("error" => "Connected!");
				}
			} else {
				$this->result = array("error" => "Error users not found");
			}
		}
		return $this->sendJsonResult();
	}
	
	protected function addNotification($idUser,$type) {
		if($this->checkSession()) {
			$ins = "insert into notifications (idUser, message)
					values ('$idUser','$type')";
			return $this->insert($ins);
		}
	}
	protected function viewNotification($session) {
		if($this->checkSession()) {
			$idUser = $_SESSION["user"]["Id"];
			$ins = "select * from notifications where idUser='$idUser and date is null'";
			if($data = $this->db->select($sql)) {
				//Marquem com a lleguides les notificacions
				$upd = "update notifiactions set date=now() where idUser='$idUser' and date is null";
				$this->update($upd);
				$this->result = array("success" => "New notifications", "notifications" => $data);
			} else {
				$this->result = array("error" => "No results found");
			}
		}
		return $this->sendJsonResult();
	}
	
	public function deleteConnection($idUserB) {
		if($this->checkSession()) {
			$idUserA = $_SESSION["user"]["Id"];
			$dataA = $this->getUserId($idUserA);
			$dataB = $this->getUserId($idUserB);
			if($dataA && $dataB) {
				$sql = "delete 
						from userfriends 
						where IdUserA='$idUserA' and IdUserB='$idUserB'";
				if($this->db->delete($sql)) {
					$this->result = array("success" => "Connection deleted");
				} else {
					$this->result = array("error" => "Error deleting connection");
				}
			} else {
				$this->result = array("error" => "Error users not found");
			}
		}
		return $this->sendJsonResult();
	}
	
	/**********************	FI SUBSISTEMA GESTIO AMISTATS ********************/
	
	public function getCurrentLocation($idUser) {
		$this->init();
		$sql = "select longitud, latitud, date as last_seen 
				from currentlocation 
				where IdUser=".$idUser;
		if($data = $this->db->select($sql)) {
			return $data[0];
		}
		return false;
	}
	
	public function updateUser($name, $profile, $password = "") {
		if($name && $this->checkSession()) {
			$idUser = $_SESSION["user"]["Id"];
			$sql = "update users set name='".$name."', profile='$profile'";
			if($password != "" && $password != "o0") {
				$sql .= ", password='".$password."'";
			}
			$sql .= " where Id=".$idUser;
			if($this->db->update($sql)) {
				$this->result = array("success" => "User updated");
			} else {
				$this->result = array("error" => "Error updating user");
			}
		}
		return $this->sendJsonResult();
	}
	
	public function updateAutolocation($autolocation) {
		if($this->checkSession()) {
			$idUser = $_SESSION["user"]["Id"];
			$upd = "update users set autolocation='$autolocation' where Id='$idUser'";
			if($this->db->update($upd)) {
				$this->result = array("success" => "Autolocation updated");
			} else {
				$this->result = array("error" => "Error updating autolocation");
			}
		}
		return $this->sendJsonResult();
	}
	
	public function updateLocation($longitud,$latitud,$autolocation) {
		if($this->checkSession()) {
			$idUser = $_SESSION["user"]["Id"];
			//Guardem el mode de localització
			$this->updateAutolocation($autolocation);
			//Agafem la posicio que tenim guardada
			$old = $this->getCurrentLocation($idUser);
			if($old) {
				if($old["longitud"] != $longitud || $old["latitud"] != $latitud) {
					//Actualitzem l'historial
					$sql = "insert into historylocations (idUser,date,longitud,latitud) 
							values ('$idUser','".$old["last_seen"]."','".$old["longitud"]."','".$old["latitud"]."')";
					//print $sql."<br>";die;
					$this->db->insert($sql);
					//Actualitzem la posició actual
					$sql = "update currentlocation 
							set date=now(), longitud='$longitud', latitud='$latitud' 
							where idUser='$idUser'";
					//print $sql."<br>";
					if($this->db->update($sql)) {
						$this->result = array("success" => "Location updated");
					} else {
						$this->result = array("error" => "Error updating location");
					}
				} else {
					$this->result = array("error" => "Error, same location");
				}
			} else {
			 	$sql = "insert into currentlocation (idUser,date,longitud,latitud) 
						values ('$idUser',now(),'$longitud','$latitud')";
				//print $sql."<br>";
				if($this->db->insert($sql)) {
					$this->result = array("success" => "Location inserted");
				} else {
					$this->result = array("error" => "Error inserting location");
				}
			}
		}
		return $this->sendJsonResult();
	}
	
	public function searchByName($name) {
		if($this->checkSession()) {
			$idUser = $_SESSION["user"]["Id"];
			
			$sql = "select b.Id,b.email,b.name,c.longitud,c.latitud,c.date as last_seen
					from users as b inner join currentlocation as c on b.Id=c.IdUser
					where b.name like '%$name%' and b.profile=1 ";
			if($friends = $this->getFriends($idUser)) {
				$sql .= " and b.Id not in ('$idUser'";
				foreach($friends as $key => $item) {
					$sql .= ",'".$item["Id"]."'";
				}
				$sql .= ")";
			} else {
				$sql .= " and b.Id <> '$idUser'";
			}
			
			$sql .= " order by name";
			//print $sql;
			if($data = $this->db->select($sql)) {
				$this->result = array("success" => "Ok", "friends" => $data);
			} else {
				$this->result = array("error" => "No results found");
			}
		}
		return $this->sendJsonResult();
	}
	
	
	/**********************	SUBSISTEMA ENVIAMENT D'EMAILS ********************/
	protected function activateEmailAccount($email, $name, $secure) {
		
		include("libs/PHPMailer_v5.1/class.phpmailer.php");
	
		$mail             = new PHPMailer();

		$mail->IsSMTP(); 									// telling the class to use SMTP
		$mail->SMTPAuth   	= true;                  		// enable SMTP authentication
		$mail->SMTPSecure 	= "ssl";                 		// sets the prefix to the servier
		$mail->Host       	= "smtp.gmail.com";      		// sets GMAIL as the SMTP server
		$mail->Port       	= 465; //587                  		// set the SMTP port for the GMAIL server
		$mail->Username   	= "XXXXXXXX@gmail.com";  	// GMAIL username
		$mail->Password   	= "";            		// GMAIL password
		$mail->setFrom('XXXXXXXX@gmail.com', 'FindMe!');	// From
		$mail->IsHTML(true);    							// set email format to HTML
		
		$mail->AddAddress($email, $name);
		
		$mail->Subject		= "FindMe : Activate account!";	// Subject
		
		$link = "<a href='http://localhost/findme/client.php?secure=$secure'>http://localhost/findme/client.php?secure=$secure</a>";
		$body             	= "<html><head><title>FindMe: Activate account!</title></head><body><h2>FindMe: Activate account!</h2><p>Please, activate your account before you can use it : $link</p></body></html>";
		$body             	= eregi_replace("[\]",'',$body);
		$mail->Body 		= $body;						// Body

		if(!$mail->Send()) {
			return false;
		} else {
			return true;
		}
	}
    
}

?>