<?php

/**
* Clase Request. Tractament de variables (post,get,sessio,globals)
*
* @author   Javi Filella <txusko@gmail.com>
* @created  17-01-06 10:46
**/
class Request
{
    var $mRequest = array();
    var $mPost = array();
    var $mGet = array();
    var $mSession = array();

    function __construct() {
    }

    function getRequest($var = "") {
        if($var) {
            foreach($_REQUEST as $key => $value) {

                if($key == $var)
                    return $value;
            }
        }
        return false;
    }

    function getPost($var = "") {
        if($var) {
            foreach($_POST as $key => $value) {
                if($key == $var)
                    return $value;
            }
        }
        return false;
    }

    function getGet($var = "") {
        if($var) {
            foreach($_GET as $key => $value) {
                if($key == $var) {
                    return $value;
                }
            }
        }
        return false;
    }

    function getSession($var = "") {
        if($var && isset($_SESSION)) {
            foreach($_SESSION as $key => $value) {
                if($key == $var)
                    return trim($value);
            }
        }
        return false;
    }

    function getFile($var = "") {
        if($var && isset($_FILES)) {
            foreach($_FILES as $key => $value) {
                if($key == $var) {
                    return $value;
                }
            }
        }
        return false;
    }

    /*function parseVar($value = "") {
        $newValue = addSlashes($value);
        return $newValue;
    }*/
    function getVar($id,$op="request",$parse=true,$mysql=false,$js=false,$tags=true) {
        $var = "";
        $id = trim($id);
        if($id) {
            switch($op) {
                case 'request':
                    $var = Request::getRequest($id);
                    break;
                case 'get':
                    $var = Request::getGet($id);
                    break;
                case 'post':
                    $var = Request::getPost($id);
                    break;
                case 'session':
                    $var = Request::getSession($id);
                    break;
                case 'files':
                    $var = Request::getFile($id);
                    break;
                default:
                    $var = "";
                    break;
            }
        }
        if($parse)
            $var = Request::parseVar($var,$mysql,$js,$tags);
        return $var;
    }
    function getSecureVar($id,$op="request") {
        $var = Request::getVar($id,$op,true,true,false,true);
        $var = mysql_escape_string($var);
        return $var;
    }
    function parseVar($var,$mysql=false,$js=false,$tags=true) {
        if(!is_array($var)) {
            $var = stripslashes($var);
            //$var = ereg_replace("\"","&quot;",$var);
            if($mysql) {
                //$var = ereg_replace("'","''",$var);
                //$var = mysql_escape_string($var);
                $var = mysql_real_escape_string($var);
            }
            if($js) {
                $var = ereg_replace("<br>","\n",$var);
                $var = ereg_replace("<br/>","\n",$var);
                $var = ereg_replace("<br />","\n",$var);
                $var = ereg_replace("</tr>","</tr>\n",$var);
            }
            if($tags) {
                $var = strip_tags($var);
            }
        }
        return $var;
    }
    function xmlentities($string) {
        if ( strlen($string) == 0 )
            return $string;
        $result = '';
        $string = htmlentities($string, HTML_ENTITIES);
        $string = preg_split("//", $string, -1, PREG_SPLIT_NO_EMPTY);
        $ord = 0;
        for ( $i = 0; $i < count($string); $i++ ) {
            $ord = ord($string[$i]);
            if ( $ord > 127 ) {
                $string[$i] = '&#' . $ord . ';';
            }
        }
        return implode('',$string);
    }
    function is_Set($id,$op = "request") {
        $id = trim($id);
        if($id) {
            switch($op) {
                case 'request':
                    if(isset($_REQUEST[$id]))
                        return true;
                    break;
                case 'get':
                    if(isset($_GET[$id]))
                        return true;
                    break;
                case 'post':
                    if(isset($_POST[$id]))
                        return true;
                    break;
                case 'session':
                    if(isset($_SESSION[$id]))
                        return true;
                    break;
                default:
                    return false;
                    break;
            }
        }
        return false;
    }

    function setVar($id,$value,$op = "session") {
        $id = trim($id);
        $value = trim($value);
        if($id) {
            switch($op) {
                case 'request':
                    $_REQUEST[$id] = $value;
                    break;
                case 'get':
                    $_GET[$id] = $value;
                    break;
                case 'post':
                    $_POST[$id] = $value;
                    break;
                case 'session':
                    $_SESSION[$id] = $value;
                    break;
                default:
                    break;
            }
        }
    }

    function showVar($var="request",$die = 0) {
        switch(@strtolower($var)) {
            case 'session':
                Request::showArray($_SESSION,$die);
                break;
            case 'get':
                Request::showArray($_GET,$die);
                break;
            case 'post':
                Request::showArray($_POST,$die);
                break;
            case 'request':
                Request::showArray($_REQUEST,$die);
                break;
            default:
                Request::showArray($var,$die);
                break;
        }
    }


    function showArray($array = array(), $die = 0) {
        print "<pre>****************************************";
        print "</br>Tipo:".gettype($array)."";
        print "</br>Contenido:";print_r($array);
        print "</br>****************************************</pre>";
        if($die) 
        	die;
    }

    function post($server = "localhost", $uri = "/index.php", $port = "80", $vars = "") {
        $page .= "POST ".$uri." HTTP/1.0\r\n";
        $page .= "Host: ".$server.":".$port."\r\n";
        $page .= "Content-Type: application/x-www-form-urlencoded\r\n";
        $page .= "Content-Length: " . strlen($vars) . "\r\n\r\n";
        $page .= $vars;
        $protocol=($port==443)?'ssl':'http';

        $fp = fsockopen ($protocol.'://'.$server, $port, $errno, $errstr, 30);

        if (!$fp) {
            die($errno .": ". $errstr);
        } else {
            fputs ($fp,$page);
            $cont="";
            while (!feof($fp)) {
                $cont.=fgets($fp);
            }
            fclose ($fp);
            return $cont;
        }
    }


}

function showArray($var="request",$die=0) {
    Request::showArray($var,$die);
}

function showVar($var="request",$die=0) {
    Request::showVar($var,$die);
}

function showVars() {
    print "SESSION";
    Request::showVar("session");
    print "REQUEST";
    Request::showVar("request",1);
}

function showXml($var="request",$die=0) {
    $var = simplexml_load_string($var);
    Request::showVar($var,$die);
    if($die)
        die;
}

?>