CREATE DATABASE `findme`;

-- 
-- Estructura de la taula `users`
-- 

CREATE TABLE `users` (
  `Id` int(11) NOT NULL auto_increment,
  `email` varchar(255) NOT NULL default '',
  `password` varchar(40) NOT NULL default '',
  `name` varchar(45) default NULL,
  `registered` datetime NOT NULL default '0000-00-00 00:00:00',
  `deleted` datetime default NULL,
  `last_seen` datetime NOT NULL default '0000-00-00 00:00:00',
  `profile` smallint(1) NOT NULL default '1',
  `autolocation` smallint(1) NOT NULL default '1',
  PRIMARY KEY  (`Id`),
  UNIQUE KEY `email_UNIQUE` (`email`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=24 ;


-- 
-- Estructura de la taula `currentlocation`
-- 

CREATE TABLE `currentlocation` (
  `Id` int(11) NOT NULL auto_increment,
  `IdUser` int(11) NOT NULL default '0',
  `date` datetime NOT NULL default '0000-00-00 00:00:00',
  `longitud` varchar(45) NOT NULL default '',
  `latitud` varchar(45) NOT NULL default '',
  PRIMARY KEY  (`Id`),
  UNIQUE KEY `IdUser_UNIQUE` (`IdUser`),
  KEY `Id` (`IdUser`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=12 ;

-- 
-- Restriccions per la taula `currentlocation`
-- 
ALTER TABLE `currentlocation`
  ADD CONSTRAINT `fkIdUserCurrent` FOREIGN KEY (`IdUser`) REFERENCES `users` (`Id`) ON DELETE NO ACTION ON UPDATE NO ACTION;


-- 
-- Estructura de la taula `historylocations`
-- 

CREATE TABLE `historylocations` (
  `Id` int(11) NOT NULL auto_increment,
  `IdUser` int(11) NOT NULL default '0',
  `date` datetime NOT NULL default '0000-00-00 00:00:00',
  `longitud` varchar(45) NOT NULL default '',
  `latitud` varchar(45) default NULL,
  PRIMARY KEY  (`Id`),
  UNIQUE KEY `index3` (`IdUser`,`date`),
  KEY `fkIdUser` (`IdUser`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=13 ;

-- 
-- Restriccions per la taula `historylocations`
-- 
ALTER TABLE `historylocations`
  ADD CONSTRAINT `fkIdUser` FOREIGN KEY (`IdUser`) REFERENCES `users` (`Id`) ON DELETE NO ACTION ON UPDATE NO ACTION;
        


-- 
-- Estructura de la taula `userfriends`
-- 

CREATE TABLE `userfriends` (
  `Id` int(11) NOT NULL auto_increment,
  `IdUserA` int(11) NOT NULL default '0',
  `IdUserB` int(11) NOT NULL default '0',
  `accepted` tinyint(1) default '0',
  `date` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`Id`),
  UNIQUE KEY `index2` (`IdUserA`,`IdUserB`),
  KEY `fkIdUserFriendsA` (`IdUserA`),
  KEY `fkIdUserFriendsB` (`IdUserB`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=22 ;

-- 
-- Restriccions per la taula `userfriends`
-- 
ALTER TABLE `userfriends`
  ADD CONSTRAINT `fkIdUserFriendsA` FOREIGN KEY (`IdUserA`) REFERENCES `users` (`Id`) ON DELETE NO ACTION ON UPDATE NO ACTION,
  ADD CONSTRAINT `fkIdUserFriendsB` FOREIGN KEY (`IdUserB`) REFERENCES `users` (`Id`) ON DELETE NO ACTION ON UPDATE NO ACTION;