<?php

require_once("libs/FindMe.inc.php");
require_once("libs/nusoap/lib/nusoap.php");

// Create the server instance
$server = new soap_server();

// Initialize WSDL support
$server->configureWSDL('findmewsdl', 'urn:findmewsdl');


//StandarReturn (objeto con 2 vars)
$server->wsdl->addComplexType(
    'StandarReturn',
    'complexType',
    'struct',
    'all',
    '',
    array(
        'state' 	=> array('name' => 'state', 	'type' => 'xsd:int'),
        'return'    => array('name' => 'return', 	'type' => 'xsd:String')
    )
);



// Register the method to expose
$server->register('login',                // method name
    array('login' => 'xsd:string', "password" => "xsd:string"),        // input parameters
    array('return' => 'tns:StandarReturn'),      // output parameters
    'urn:findmewsdl',                      // namespace
    'urn:findmewsdl#login',                // soapaction
    'rpc',                                // style
    'encoded',                            // use
    'User login'            // documentation
);

$server->register('getUserInfo',                // method name
    array('session_id' => 'xsd:string'),        // input parameters
    array('return' => 'xsd:string'),      // output parameters
    'urn:findmewsdl',                      // namespace
    'urn:findmewsdl#getUserInfo',                // soapaction
    'rpc',                                // style
    'encoded',                            // use
    'User info'            // documentation
);

$server->register('signUp', 
	array('login' => 'xsd:string','password' => 'xsd:string'), 
	array('return' => 'xsd:string'),
	'urn:findmewsdl',
	'urn:findmewsdl#signUp',
	'rpc', 'encoded','signUp');
$server->register('updateUser', 
	array('session_id' => 'xsd:string','name' => 'xsd:string','profile' => 'xsd:string', 'password' => 'xsd:string'), 
	array('return' => 'xsd:string'),
	'urn:findmewsdl',
	'urn:findmewsdl#updateUser',
	'rpc', 'encoded','updateUser');

$server->register('deleteAccount', 
	array('session_id' => 'xsd:string','name' => 'xsd:string','password' => 'xsd:string'), 
	array('return' => 'xsd:string'),
	'urn:findmewsdl',
	'urn:findmewsdl#deleteAccount',
	'rpc', 'encoded','deleteAccount');
	
$server->register('updateLocation', 
	array('session_id' => 'xsd:string','longitud' => 'xsd:string','latitud' => 'xsd:string','autolocation' => 'xsd:string'), 
	array('return' => 'xsd:string'),
	'urn:findmewsdl',
	'urn:findmewsdl#updateLocation',
	'rpc', 'encoded','updateLocation');

$server->register('updateAutolocation', 
	array('session_id' => 'xsd:string','autolocation' => 'xsd:string'), 
	array('return' => 'xsd:string'),
	'urn:findmewsdl',
	'urn:findmewsdl#updateAutolocation',
	'rpc', 'encoded','updateAutolocation');


$server->register('searchByName', 
	array('session_id' => 'xsd:string','name' => 'xsd:string'), 
	array('return' => 'xsd:string'),
	'urn:findmewsdl',
	'urn:findmewsdl#searchByName',
	'rpc', 'encoded','searchByName');
$server->register('addFriend', 
	array('session_id' => 'xsd:string','idUser' => 'xsd:string'), 
	array('return' => 'xsd:string'),
	'urn:findmewsdl',
	'urn:findmewsdl#addFriend',
	'rpc', 'encoded','addFriend');
$server->register('viewNotification', 
	array('session_id' => 'xsd:string'), 
	array('return' => 'xsd:string'),
	'urn:findmewsdl',
	'urn:findmewsdl#viewNotification',
	'rpc', 'encoded','viewNotification');
$server->register('getFriends', 
	array('session_id' => 'xsd:string'), 
	array('return' => 'xsd:string'),
	'urn:findmewsdl',
	'urn:findmewsdl#getFriends',
	'rpc', 'encoded','getFriends');	

// Define the method as a PHP function
function login($login, $password) {
	$findme = new FindMe();
	$data = $findme->signIn($login, $password);
	if(isset($data["success"])) {
		return array("state" => 1, "return" => $findme->getSessionId());
	} elseif(isset($data["error"])) {
		return array("state" => 0, "return" => $data["error"]);
	}
	return array("state" => 0, "return" => "Undefined");
}

function signUp($login,$password) {
	$findme = new FindMe();
	return $findme->signUp($login,$password);
}
function getUserInfo($session_id) {
	$findme = new FindMe($session_id);
	return $findme->getUserInfo();
}
function updateUser($session_id,$name,$profile,$password="") {
	$findme = new FindMe($session_id);
	return $findme->updateUser($name,$profile,$password);
}
function deleteAccount($session_id,$name,$password) {
	$findme = new FindMe($session_id);
	return $findme->deleteAccount($name,$password);
}
function updateLocation($session_id,$longitud,$latitud,$autolocation) {
	$findme = new FindMe($session_id);
	return $findme->updateLocation($longitud,$latitud,$autolocation);
}
function updateAutolocation($session_id,$autolocation) {
	$findme = new FindMe($session_id);
	return $findme->updateAutolocation($autolocation);
}
function searchByName($session_id,$name) {
	$findme = new FindMe($session_id);
	return $findme->searchByName($name);
}
function addFriend($session_id,$idUser) {
	$findme = new FindMe($session_id);
	return $findme->addFriend($idUser);
}
function viewNotification($session_id) {
	$findme = new FindMe($session_id);
	return $findme->viewNotification();
}
function getFriends($session_id) {
	$findme = new FindMe($session_id);
	return $findme->getFriendsJson();
}


// Use the request to (try to) invoke the service
$HTTP_RAW_POST_DATA = isset($HTTP_RAW_POST_DATA) ? $HTTP_RAW_POST_DATA : '';
$server->service($HTTP_RAW_POST_DATA);


?>